diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40fc..cc3de4c92 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,4 +1,8 @@
+require "socket"
+
 require "hive/config"
+require "hive/invoked_binary"
+require "hive/pid_file"
 require "hive/web/session_secret"
 
 module Hive
@@ -6,18 +10,29 @@ module Hive
     # Boots the hivebox web UI — a Rails app living in web/ at the repo root
     # (shipped in the Docker image at /app/web). hive itself stays a plain
     # CLI gem; the web tier is only supported where the Rails app and its
-    # bundle exist: the hivebox container or a source checkout.
+    # bundle exist: the hivebox container, a source checkout, or a
+    # provisioned local install (see Hive::Web::AppProvisioner).
     class Web
-      def initialize(bind: nil, port: nil)
+      include Hive::PidFile
+
+      # Binds that only expose the UI to processes on the same host. A
+      # loopback bind with effective auth `none` is the zero-config local
+      # mode: no GitHub sign-in gate.
+      LOOPBACK_BINDS = %w[127.0.0.1 localhost ::1].freeze
+
+      def initialize(bind: nil, port: nil, unsafe_public: false)
         @bind = bind
         @port = port
+        @unsafe_public = unsafe_public
+        @hive_home = Hive::Paths.state_home
       end
 
       def call
         cfg = Hive::Config.load_global_web
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
-        app_dir = rails_app_dir
+        auth_mode = resolve_auth_mode!(bind, cfg)
+        app_dir = rails_app_dir || provision_app_dir!(cfg)
         unless app_dir
           warn "hive web: the hivebox web app (web/) was not found. " \
                "Run from the hivebox Docker image or a source checkout, " \
@@ -35,6 +50,10 @@ module Hive
           "SECRET_KEY_BASE" => ENV["SECRET_KEY_BASE"] ||
             Hive::Web::SessionSecret.load_or_create(cfg.fetch("session_secret_file")),
           "HIVEBOX_ORIGIN" => cfg.fetch("origin"),
+          # Effective auth decision made here (loopback no-auth vs GitHub
+          # owner gate) so the Rails require_login filter can honor it
+          # without re-deriving the bind address.
+          "HIVEBOX_AUTH_MODE" => auth_mode,
           # The solid_cable/cache/queue sqlite files must survive image
           # upgrades — keep them in state_home (on /data in the container),
           # not in the app dir.
@@ -62,8 +81,212 @@ module Hive
         end
       end
 
+      # ── Managed lifecycle (U4) ──────────────────────────────────
+      # The web tier gets the same per-user service contract as the
+      # daemon: `install [--force]` writes + enables a systemd-user/
+      # launchd unit; `start` / `stop` drive it (falling back to a
+      # detached foreground process with a pidfile where no user service
+      # manager exists); `status [--json]` reports without mutating.
+      # Foreground `call` above never touches any of this.
+
+      def pid_file
+        File.join(@hive_home, ".web.pid")
+      end
+
+      def web_log_file
+        File.join(@hive_home, "logs", "web.log")
+      end
+
+      def install_service!(force:, json: false)
+        require "hive/commands/web/service_installer"
+        installer = ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        result = installer.install!(autostart: true, force: force)
+        unless json
+          installer.messages.each { |line| warn "hive: #{line}" }
+          case result.kind
+          when :written then puts "hive web: installed unit at #{installer.target_path}"
+          when :upgraded
+            msg = "hive web: upgraded unit at #{installer.target_path}"
+            msg += " (backup: #{result.backup_path})" if result.backup_path
+            puts msg
+          when :unchanged then puts "hive web: unit already up to date at #{installer.target_path}"
+          when :autostart_unavailable
+            puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+          end
+        end
+        if json
+          require "json"
+          puts JSON.generate(
+            "schema" => "hive-web-install",
+            "schema_version" => 1,
+            "ok" => result.success?,
+            "outcome" => result.wire_outcome,
+            "platform" => installer.envelope_platform,
+            "target_path" => installer.target_path,
+            "backup_path" => result.backup_path,
+            "restarted" => result.restarted,
+            "messages" => installer.messages.dup
+          )
+        end
+        if result.drifted?
+          raise Hive::Error,
+                "web unit at #{installer.target_path} differs from the current template. " \
+                "Re-run with `hive web install --force` to overwrite (a timestamped .bak will be saved)."
+        elsif result.failed?
+          raise Hive::Error, "hive web: service install reported a failure; see messages above"
+        end
+        result
+      end
+
+      def start_service!(json: false)
+        require "hive/commands/web/service_installer"
+        installer = ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        state = installer.service_state
+        started_via =
+          if state["service_installed"] && installer.envelope_platform != "unsupported"
+            ok = manager_start(installer)
+            raise Hive::Error, "hive web: failed to start the #{installer.service_name} service" unless ok
+
+            "service"
+          else
+            start_detached!
+            "detached"
+          end
+        puts "hive web: started (#{started_via})" unless json
+        return unless json
+
+        require "json"
+        puts JSON.generate(
+          "schema" => "hive-web-start",
+          "schema_version" => 1,
+          "ok" => true,
+          "via" => started_via
+        )
+      end
+
+      def stop_service!(json: false)
+        require "hive/commands/web/service_installer"
+        installer = ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        state = installer.service_state
+        was_running =
+          if state["service_installed"] && installer.envelope_platform != "unsupported"
+            manager_stop(installer)
+          else
+            stop_detached!
+          end
+        puts was_running ? "hive web: stopped" : "hive web: not running" unless json
+        return unless json
+
+        require "json"
+        puts JSON.generate(
+          "schema" => "hive-web-stop",
+          "schema_version" => 1,
+          "ok" => true,
+          "was_running" => !!was_running
+        )
+      end
+
+      def service_status(json: false)
+        require "hive/commands/web/service_installer"
+        cfg = Hive::Config.load_global_web
+        bind = @bind || cfg.fetch("bind")
+        port = (@port || cfg.fetch("port")).to_i
+        installer = ServiceInstaller.new(binary_path: Hive::InvokedBinary.path)
+        state = installer.service_state
+        pid = read_live_pid
+        running = pid ? true : port_open?(bind, port)
+        payload = {
+          "schema" => "hive-web-status",
+          "schema_version" => 1,
+          "ok" => true,
+          "running" => running,
+          "pid" => pid,
+          "bind" => bind,
+          "port" => port,
+          "service_installed" => state["service_installed"],
+          "service_enabled" => state["service_enabled"],
+          "unit_path" => state["unit_path"],
+          # Same graceful fallback as the daemon guard: the web tier may not
+          # have been invoked through a hive binary (rails test runner).
+          "resolved_binary" => Hive::InvokedBinary.path ||
+                               Hive::InvokedBinary.which("hive") || "hive"
+        }
+        if json
+          require "json"
+          puts JSON.generate(payload)
+        elsif running
+          puts "hive web: running (#{pid ? "pid #{pid}" : "port #{port} responsive"})"
+        else
+          puts "hive web: not running"
+        end
+        raise Hive::Error, "web not running" unless running
+      end
+
       private
 
+      def manager_start(installer)
+        case installer.envelope_platform
+        when "linux" then system("systemctl", "--user", "start", installer.service_name)
+        when "macos" then system("launchctl", "load", installer.target_path)
+        end
+      end
+
+      def manager_stop(installer)
+        case installer.envelope_platform
+        when "linux" then system("systemctl", "--user", "stop", installer.service_name)
+        when "macos" then system("launchctl", "unload", installer.target_path)
+        end
+      end
+
+      # No user service manager (or no unit yet): run the same command the
+      # unit would have run, detached, with output captured in web.log.
+      def start_detached!
+        live = read_live_pid
+        if live
+          warn "hive web: already running (pid #{live})"
+          return
+        end
+        FileUtils.mkdir_p(File.dirname(web_log_file))
+        log = File.open(web_log_file, "a")
+        pid = Process.spawn(Hive::InvokedBinary.path, "web", out: log, err: log, pgroup: true)
+        log.close
+        File.write(pid_file, pid_file_payload(pid).to_yaml)
+        Process.detach(pid)
+      end
+
+      def stop_detached!
+        pid = read_live_pid
+        return false unless pid
+
+        send_signal_safely(pid, "TERM")
+        deadline = Time.now + 10
+        while pid_alive?(pid) && Time.now < deadline
+          # Reap if it is our own child — a TERMed child lingers as a zombie
+          # until waited, and pid_alive? cannot distinguish zombie from live.
+          begin
+            Process.waitpid(pid, Process::WNOHANG)
+          rescue Errno::ECHILD
+            break # not our child; nothing to reap
+          end
+          sleep 0.2
+        end
+        send_signal_safely(pid, "KILL") if pid_alive?(pid)
+        begin
+          Process.waitpid(pid, Process::WNOHANG)
+        rescue Errno::ECHILD
+          # not our child
+        end
+        FileUtils.rm_f(pid_file)
+        true
+      end
+
+      def port_open?(bind, port)
+        host = LOOPBACK_BINDS.include?(bind.to_s) ? "127.0.0.1" : bind.to_s
+        ::Socket.tcp(host, port, connect_timeout: 0.5) { |_sock| true }
+      rescue SystemCallError, IOError
+        false
+      end
+
       def rails_app_dir
         candidates = [
           ENV["HIVEBOX_WEB_APP_DIR"],
@@ -72,6 +295,58 @@ module Hive
         candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
       end
 
+      # Last-resort source for the Rails app on gem installs: ask the
+      # provisioner for a version-matched copy under XDG data home. Failure
+      # is a typed error listing what was tried; rails_app_dir candidates
+      # always win when present.
+      def provision_app_dir!(cfg)
+        require "hive/web/app_provisioner"
+        provisioner = Hive::Web::AppProvisioner.new
+        dir = provisioner.provision
+        warn "hive web: using provisioned web app at #{dir}" if dir
+        dir
+      rescue Hive::Error => e
+        warn "hive web: #{e.message}"
+        nil
+      end
+
+      # Resolve the effective auth mode from config + bind:
+      #
+      #   auto   → none on a loopback bind, github otherwise (the hivebox
+      #            posture: the container binds 0.0.0.0 and resolves to
+      #            github exactly as before this key existed).
+      #   none   → no sign-in; refused outright on a non-loopback bind
+      #            unless --unsafe-public / web.allow_public_unsafe.
+      #   github → owner gate regardless of bind (Docker parity).
+      #
+      # The refusal names all three remediations so the operator can fix it
+      # without reading docs.
+      def resolve_auth_mode!(bind, cfg)
+        configured = cfg.fetch("auth", "auto")
+        loopback = loopback_bind?(bind)
+        mode =
+          if configured == "auto"
+            loopback ? "none" : "github"
+          else
+            configured
+          end
+
+        if mode == "none" && !loopback && !@unsafe_public && !cfg["allow_public_unsafe"]
+          raise Hive::Error,
+                "hive web: refusing to bind #{bind} without authentication. " \
+                "Pick one: (1) bind loopback instead (`--bind 127.0.0.1`), " \
+                "(2) set `web.auth: github` in the global config to require the " \
+                "GitHub owner sign-in, or (3) pass `--unsafe-public` to accept an " \
+                "unauthenticated network-exposed UI."
+        end
+
+        mode
+      end
+
+      def loopback_bind?(bind)
+        LOOPBACK_BINDS.include?(bind.to_s.strip.downcase)
+      end
+
       # Rails' production host authorization is inactive by default — the box
       # assumes a trusted reverse proxy validates Host, exactly like the
       # pre-Rails posture. Binding a public interface without that proxy
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 000000000..a6526a8b1
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,68 @@
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart installer for the web tier (U4) — a SEPARATE
+      # service from the daemon (R8): systemd-user `hive-web.service` /
+      # launchd `local.hive-web`. Reuses ServiceInstaller::Base mechanics
+      # verbatim (backup rotation, force-upgrade restart, unsupported-host
+      # outcome); only identity + templates differ from the daemon.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          # systemd .service files are POSIX-shell-ish — escape the resolved
+          # binary path so whitespace, `%`, or other special characters don't
+          # produce a malformed unit. (Same treatment as hive-daemon.service.)
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web")
+            .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{escaped}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          # dirname BEFORE HTML-escaping so paths with `&`/`<`/`>` get the
+          # correct directory segmentation; then escape both for plist XML.
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index da8bd31af..b68c5cb38 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -373,6 +373,15 @@ module Hive
         "bind" => "127.0.0.1",
         "port" => 4567,
         "origin" => "http://127.0.0.1:4567",
+        # Local (non-Docker) auth mode. `auto` resolves at `hive web` boot:
+        # `none` on a loopback bind (no sign-in for a private localhost UI),
+        # `github` otherwise — which is exactly the hivebox posture, since
+        # the container binds 0.0.0.0. `none`/`github` pin the mode
+        # explicitly. A non-loopback bind with effective auth `none` is
+        # refused unless web.allow_public_unsafe is true (or the CLI passes
+        # --unsafe-public).
+        "auth" => "auto",
+        "allow_public_unsafe" => false,
         "github" => {
           "owner" => nil,
           # The shared hivebox OAuth app (device flow only — public by
@@ -593,6 +602,11 @@ module Hive
     # deliberate review point here, not a silent propagation — if DIRS
     # changes, update this list to match.
     DEPENDENCY_GATE_STAGES = %w[8-finalize 9-done].freeze # coding-scoped: coding dependency-gate stages (last two of Stages::DIRS)
+
+    # Effective auth modes for `hive web`. `auto` is the default and
+    # resolves to `none` on a loopback bind, `github` otherwise (see
+    # Hive::Commands::Web#resolve_auth_mode!).
+    WEB_AUTH_MODES = %w[auto none github].freeze
     EXPLICIT_CLAUDE_MODE_KEY = :__hive_explicit_claude_mode
     EXPLICIT_BRAINSTORM_RUNTIME_KEY = :__hive_explicit_brainstorm_runtime
 
@@ -2277,6 +2291,20 @@ module Hive
               "web.origin in #{describe_source(source_path)} must be an http(s) URL"
       end
 
+      auth = web["auth"]
+      unless WEB_AUTH_MODES.include?(auth)
+        raise ConfigError,
+              "web.auth in #{describe_source(source_path)} must be one of " \
+              "#{WEB_AUTH_MODES.inspect}; got #{auth.inspect} (#{auth.class})"
+      end
+
+      allow_public_unsafe = web["allow_public_unsafe"]
+      unless allow_public_unsafe.nil? || allow_public_unsafe == true || allow_public_unsafe == false
+        raise ConfigError,
+              "web.allow_public_unsafe in #{describe_source(source_path)} must be a boolean " \
+              "(true / false); got #{allow_public_unsafe.inspect} (#{allow_public_unsafe.class})"
+      end
+
       github = web["github"]
       unless github.is_a?(Hash)
         raise ConfigError,
diff --git a/lib/hive/setup/daemon_guard.rb b/lib/hive/setup/daemon_guard.rb
new file mode 100644
index 000000000..794e895e9
--- /dev/null
+++ b/lib/hive/setup/daemon_guard.rb
@@ -0,0 +1,140 @@
+require "rbconfig"
+require "shellwords"
+
+require "hive"
+require "hive/commands/daemon/service_installer"
+require "hive/invoked_binary"
+require "hive/pid_file"
+require "hive/paths"
+
+module Hive
+  module Setup
+    # Daemon binary/version consistency guard (U5). After `hive setup`, the
+    # hive-daemon user service must run the SAME hive binary as the invoking
+    # CLI. Upgrades (brew, install.sh, gem update) silently move the binary
+    # out from under a still-installed unit; this guard detects that drift
+    # and repairs it by re-running the daemon installer with --force, which
+    # rewrites the unit to the resolved binary and restarts the service.
+    #
+    # Check outcomes:
+    #   ok            — unit installed, binary matches the invoking CLI
+    #   drifted       — unit installed but points at a different binary
+    #   not_installed — no hive-daemon unit on this host
+    #   unsupported   — no systemd-user / launchd on this host (nothing to
+    #                   guard; manual `hive daemon start` guidance applies)
+    #
+    # Running-state is a separate axis reported alongside (`running`), fed
+    # by the same pidfile contract `hive daemon status` uses.
+    class DaemonGuard
+      include Hive::PidFile
+
+      Result = Struct.new(
+        :status, :running, :pid, :unit_path, :service_binary, :expected_binary, :detail,
+        keyword_init: true
+      ) do
+        def ok?
+          status == "ok"
+        end
+
+        def healthy?
+          ok? && running
+        end
+      end
+
+      attr_reader :expected_binary
+
+      def initialize(home: nil, binary_path: nil, host_os: RbConfig::CONFIG["host_os"],
+                     runner: nil, systemctl_available: nil)
+        @installer = Hive::Commands::Daemon::ServiceInstaller.new(
+          host_os: host_os, home: home, binary_path: binary_path,
+          runner: runner, systemctl_available: systemctl_available
+        )
+        # The web tier may not have been invoked through a hive binary at
+        # all (Puma under rails test); fall back to a PATH lookup so the
+        # comparison degrades gracefully instead of crashing.
+        resolved = binary_path || Hive::InvokedBinary.path ||
+                   Hive::InvokedBinary.which("hive") || "hive"
+        @expected_binary = File.expand_path(resolved)
+      end
+
+      def pid_file
+        File.join(Hive::Paths.state_home, ".daemon.pid")
+      end
+
+      def check
+        state = @installer.service_state
+        running = !!read_live_pid
+
+        return Result.new(
+          status: "unsupported", running: running, pid: read_live_pid,
+          unit_path: nil, service_binary: nil, expected_binary: @expected_binary,
+          detail: "no systemd-user / launchd service manager on this host; run `hive daemon start` manually"
+        ) if state["platform"] == "unsupported"
+
+        unless state["service_installed"]
+          return Result.new(
+            status: "not_installed", running: running, pid: read_live_pid,
+            unit_path: state["unit_path"], service_binary: nil,
+            expected_binary: @expected_binary,
+            detail: "hive-daemon unit not installed; run `hive setup` or `hive daemon install`"
+          )
+        end
+
+        service_binary = unit_binary(state["unit_path"])
+        if service_binary && !binaries_match?(service_binary, @expected_binary)
+          return Result.new(
+            status: "drifted", running: running, pid: read_live_pid,
+            unit_path: state["unit_path"], service_binary: service_binary,
+            expected_binary: @expected_binary,
+            detail: "daemon unit runs #{service_binary} but this CLI is #{@expected_binary}; " \
+                    "repair with `hive setup` (or `hive daemon install --force`)"
+          )
+        end
+
+        Result.new(
+          status: "ok", running: running, pid: read_live_pid,
+          unit_path: state["unit_path"], service_binary: service_binary,
+          expected_binary: @expected_binary, detail: nil
+        )
+      end
+
+      # Repair = re-run the daemon installer with --force: the unit is
+      # rewritten to the resolved binary and the service restarts (Linux) /
+      # reloads (macOS). Idempotent — a matching unit comes back :unchanged.
+      def repair!
+        @installer.install!(autostart: true, force: true)
+      end
+
+      private
+
+      # Extract the hive binary a unit would execute. systemd: first token
+      # of ExecStart= (Shellwords-escaped at render time). launchd: the
+      # ProgramArguments entry whose basename is `hive` (the template wraps
+      # the invocation in /bin/sh, so it is never the first string).
+      def unit_binary(unit_path)
+        return nil unless unit_path && File.file?(unit_path)
+
+        content = File.read(unit_path)
+        if unit_path.end_with?(".service")
+          line = content.lines.find { |l| l.start_with?("ExecStart=") }
+          return nil unless line
+
+          Shellwords.split(line.sub(/\AExecStart=/, "").strip).first
+        else
+          strings = content.scan(%r{<string>([^<]*)</string>}).flatten
+          strings.map { |s| CGI.unescapeHTML(s) }
+                 .find { |s| File.basename(s) == "hive" }
+        end
+      end
+
+      # Compare through symlinks when both paths exist (brew/install.sh
+      # symlink chains), falling back to literal equality for paths that
+      # do not resolve on this host.
+      def binaries_match?(a, b)
+        real_a = File.exist?(a) ? File.realpath(a) : a
+        real_b = File.exist?(b) ? File.realpath(b) : b
+        real_a == real_b
+      end
+    end
+  end
+end
